<script setup lang="ts">
import { useMetadataStore } from "@/stores/useMetadataStore";

// Auth and metadata store
const { data: session, signOut } = useAuth();
const metadataStore = useMetadataStore();

// State for the confirmation dialog
const dialogConfirmLeave = ref(false);

// Function triggered by the sign-out button
async function handleSignOut() {
  // Check if there are unsaved changes
  if (metadataStore.unsavedMetadata.node === true) {
    dialogConfirmLeave.value = true; // Show confirmation dialog
  } else {
    await signOut({ callbackUrl: "/" }); // Proceed with sign-out if no unsaved changes
  }
}

// Function to handle the dialog response
async function confirmSignOut(response: string) {
  dialogConfirmLeave.value = false;
  if (response === "yes") {
    metadataStore.unsavedMetadata.node = false; // Reset unsaved changes
    await signOut({ callbackUrl: "/" }); // Sign out the user
  }
}
</script>

<template>
  <div class="d-flex mt-6 align-center">
    <div class="me-auto">
      <div class="d-flex">
        <img
          :src="getGravatar(session?.user?.email)"
          alt=""
          style="border-radius: 50%; margin: 0; padding: 0; max-height: 24px"
          class="me-3 align-self-center"
        >
        <div id="username">
          {{ session?.user?.name }}
        </div>
      </div>
    </div>
    <div>
      <v-btn
        icon="mdi-logout"
        color="plain"
        variant="plain"
        size="normal"
        @click="handleSignOut"
      />
    </div>
  </div>

  <!-- Confirmation dialog for unsaved changes -->
  <v-dialog
    v-model="dialogConfirmLeave"
    persistent
    max-width="500px"
  >
    <v-card>
      <v-card-title class="headline">
        Unsaved Changes
      </v-card-title>
      <v-card-text>
        You have unsaved changes. Do you really want to sign out without saving?
      </v-card-text>
      <v-card-actions>
        <v-spacer />
        <v-btn @click="confirmSignOut('no')">
          No
        </v-btn>
        <v-btn color="error" @click="confirmSignOut('yes')">
          Yes
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
